﻿using System;
using System.Linq;
using System.Windows;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Telerik.Windows.Controls.TreeListView;
using Telerik.Windows.Controls;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			DataContext = new ObservableCollection<MyObject>(from i in Enumerable.Range(0, 100000)
															 select new MyObject()
																 {
																	 Property1 = string.Format("Property1{0}", i),
																	 Property2 = string.Format("Property2{0}", i),
																	 Property3 = string.Format("Property3{0}", i),
																	 Property4 = string.Format("Property4{0}", i),
																	 Property5 = string.Format("Property5{0}", i),
																	 Property6 = string.Format("Property6{0}", i),
																	 Property7 = string.Format("Property7{0}", i),
																	 Property8 = string.Format("Property8{0}", i),
																	 Property9 = string.Format("Property9{0}", i),
																	 Property10 = string.Format("Property10{0}", i),
																 });
		}

		private void RadTreeListView_RowIsExpandedChanged(object sender, Telerik.Windows.Controls.GridView.RowEventArgs e)
		{
			var item = (MyObject)e.Row.DataContext;

			if (((TreeListViewRow)e.Row).IsExpanded)
			{
				item.Items = new ObservableCollection<MyObject>(from i in Enumerable.Range(0, 100000)
																select new MyObject()
																	{
																		Property1 = string.Format("Property1{0}", i),
																		Property2 = string.Format("Property2{0}", i),
																		Property3 = string.Format("Property3{0}", i),
																		Property4 = string.Format("Property4{0}", i),
																		Property5 = string.Format("Property5{0}", i),
																		Property6 = string.Format("Property6{0}", i),
																		Property7 = string.Format("Property7{0}", i),
																		Property8 = string.Format("Property8{0}", i),
																		Property9 = string.Format("Property9{0}", i),
																		Property10 = string.Format("Property10{0}", i),
																	});
			}
			else
			{
				item.Items = null;
			}
		}
	}

	public class MyObject : INotifyPropertyChanged
	{
		public string Property1 { get; set; }
		public string Property2 { get; set; }
		public string Property3 { get; set; }
		public string Property4 { get; set; }
		public string Property5 { get; set; }
		public string Property6 { get; set; }
		public string Property7 { get; set; }
		public string Property8 { get; set; }
		public string Property9 { get; set; }
		public string Property10 { get; set; }

		ObservableCollection<MyObject> items;
		public ObservableCollection<MyObject> Items
		{
			get
			{
				return items;
			}
			set
			{
				if (items != value)
				{
					items = value;

					OnPropertyChanged("Items");
				}
			}
		}

		#region INotifyPropertyChanged Members

		public event PropertyChangedEventHandler PropertyChanged;

		private void OnPropertyChanged(string propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

		#endregion
	}
}
